#include <tamtypes.h>
#include <kernel.h>
#include <loadfile.h>
#include <sifrpc.h>
#include <libpad.h>
#include "gsKit.h"
#include "dmaKit.h"
#include "malloc.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gsToolkit.h"
#include <libcdvd.h>
#include <osd_config.h>
#define PLAYTIME 5000

// vg^Cv錾
void creteStage(); // Xe[W
void Triple(); // 3A

// O[oϐ`
static char g_stageBuffer[9][9];
static int g_iTimer=0,g_iCountDown=0;
unsigned long g_ulScore=0;

static char padBuf[256] __attribute__((aligned(64)));
u64 White, Black, TexCol,RedFont;
GSGLOBAL *gsGlobal;
GSFONTM *gsFontM;
float fontsize=2.0f;

// KvW[̃[h
void loadModules(){
	if((SifLoadModule("rom0:XSIO2MAN", 0, NULL)) < 0){
		printf("Failed to load XSIO2MAN module\n");
		SleepThread();
	}
	if((SifLoadModule("rom0:XPADMAN", 0, NULL)) < 0){
		printf("Failed to load XPADMAN module\n");
		SleepThread();
	}
}

int main(void){
	char temp[256],charbuff=0;
	struct padButtonStatus buttons;
	u32 paddata;

	int i=0,j=0,cur_x=1,cur_y=1,old_x=0,old_y=0,keyBottom=0,iCircleLock=0;

	loadModules(); padInit(0); padPortOpen(0,0,padBuf);

	// 1.gsKit
	gsGlobal = gsKit_init_global();
	gsFontM = gsKit_init_fontm();
	dmaKit_init(D_CTRL_RELE_OFF,D_CTRL_MFD_OFF, D_CTRL_STS_UNSPEC,
		    D_CTRL_STD_OFF, D_CTRL_RCYC_8, 1 << DMA_CHANNEL_GIF);
	dmaKit_chan_init(DMA_CHANNEL_GIF);
	dmaKit_chan_init(DMA_CHANNEL_FROMSPR);
	dmaKit_chan_init(DMA_CHANNEL_TOSPR);
	Black = GS_SETREG_RGBAQ(0x00,0x00,0x00,0x00,0x00);
	White = GS_SETREG_RGBAQ(0xFF,0xFF,0xFF,0x00,0x00);
    TexCol = GS_SETREG_RGBAQ(0x80,0x80,0x80,0x80,0x00);
    RedFont = GS_SETREG_RGBAQ(0xFF,0x80,0x80,0x80,0x00);
    gsGlobal->PrimAlphaEnable = GS_SETTING_ON;
	gsKit_init_screen(gsGlobal);
	gsKit_fontm_upload(gsGlobal, gsFontM);
	gsFontM->Spacing = 0.95f; // ̖x
    gsKit_mode_switch(gsGlobal, GS_ONESHOT);
    creteStage(); // Xe[W쐬[`R[
	// 2.C[vJn
	while(1){
		// 3.L[
		padRead(0, 0, &buttons);
		paddata = buttons.btns^0xFFFF;
		if(paddata!=0 && keyBottom==0){
			old_x=cur_x; old_y=cur_y; // ړÕJ[\ʒuێ
			if(cur_x!=0 &&(paddata & PAD_LEFT)) cur_x--;
			if(cur_x!=5 &&(paddata & PAD_RIGHT)) cur_x++;
			if(cur_y!=0 &&(paddata & PAD_UP)) cur_y--;
			if(cur_y!=5 &&(paddata & PAD_DOWN)) cur_y++;
			keyBottom=1;
		}
		// A֎~
		if(paddata==0 || paddata==PAD_CIRCLE) keyBottom=0;
		// {^ɃbNL
		if(paddata==PAD_CIRCLE && iCircleLock==0){
			keyBottom=0; iCircleLock=1;
		}
		// bNړ
		if((paddata&PAD_CIRCLE) && iCircleLock==1){
			if(old_x!=cur_x || old_y!=cur_y){
				charbuff = g_stageBuffer[old_y][old_x];
				g_stageBuffer[old_y][old_x] = g_stageBuffer[cur_y][cur_x];
				g_stageBuffer[cur_y][cur_x] = charbuff;
				old_x=cur_x; old_y=cur_y; // ֖h~ōWNA
			}
		}
		// ~{^Ŕ΃[`R[
		if(paddata&PAD_CROSS) Triple();
		
		// g_iCountDown0ȊOȂ猸ZAg_iCountDown[ɂȂƌ߂
		// 0̐ΑقǁuvƂăXRA{㏸
		if(g_iCountDown!=0){
			unsigned long ulScorePlus=1;
			g_iCountDown--;
			if(g_iCountDown==0){
				for(i=0;i<=5;i++){
					for(j=0;j<=5;j++){
						if(g_stageBuffer[j][i]=='0'){
							ulScorePlus*=2;
							g_stageBuffer[j][i]=rand()%9+'1';
						}
					}
				}
				g_ulScore+=ulScorePlus;
			}
		}
		
		
		gsKit_clear(gsGlobal, White); // wiNA
		// 5.Xe[W`
		gsKit_fontm_print_scaled(gsGlobal, gsFontM, 40+cur_x*(int)fontsize*25, 40+cur_y*(int)fontsize*25, 3, fontsize+0.8f, RedFont,"O");
		for(i=0;i<=5;i++){
			gsKit_fontm_print_scaled(gsGlobal, gsFontM, 50, 50+i*(int)fontsize*24, 3, fontsize, TexCol,g_stageBuffer[i]);
		}
		sprintf(temp,"Timer:%04d Score:%08ld",g_iTimer,g_ulScore);
		gsKit_fontm_print_scaled(gsGlobal, gsFontM,0,0, 3, fontsize-1, TexCol,temp);
		g_iTimer--; // JEg_E
		
		// Q[I[o[
		if(g_iTimer==-1){
			while(1){
				gsKit_fontm_print_scaled(gsGlobal, gsFontM, 100, 150, 3, fontsize, RedFont,"GAME OVER");
				gsKit_fontm_print_scaled(gsGlobal, gsFontM, 120, 250, 3, fontsize-1.1f, TexCol,"PRESS START BUTTON");
				padRead(0, 0, &buttons);
				paddata = buttons.btns^0xFFFF;
				gsKit_sync_flip(gsGlobal);
				gsKit_queue_exec(gsGlobal);
				dmaKit_wait_fast();
				if(paddata==PAD_START) break;
			}
			g_ulScore=0; creteStage(); // Q[I[o[˔jXe[WĐ
		}

		gsKit_sync_flip(gsGlobal);
		gsKit_queue_exec(gsGlobal);
		dmaKit_wait_fast();
	}
	return 0;
}


// Xe[W֐
void creteStage(){
	int i=0,j=0;
	srand(0); // 񓯂V[hŏ
	for(i=0;i<=5;i++){
		for(j=0;j<=5;j++){
			g_stageBuffer[j][i]=rand()%9+'1';
		}
		g_stageBuffer[j][6]='\0'; // I[
	}
	g_iTimer=PLAYTIME; // JEg_E^C}[
}

// 3A
void Triple(){
	static char flash[9][9];
	int i=0,j=0;
	// tONA
	for(i=0;i<=5;i++){ for(j=0;j<=5;j++){ flash[j][i]=0; } }
	// ʒuɃtO𗧂Ă
	for(i=0;i<=5;i++){
		for(j=0;j<=5;j++){
			if(g_stageBuffer[j][i]==g_stageBuffer[j+1][i] && g_stageBuffer[j+1][i]==g_stageBuffer[j+2][i]){
				if(j<=5) flash[j][i]=1;
				if(j<=5) flash[j+1][i]=1;
				if(j<=5) flash[j+2][i]=1;
				g_iCountDown=30;
			}
			if(g_stageBuffer[j][i]==g_stageBuffer[j][i+1] && g_stageBuffer[j][i+1]==g_stageBuffer[j][i+2]){
				if(i<=5) flash[j][i]=1;
				if(i<=5) flash[j][i+1]=1;
				if(i<=5) flash[j][i+2]=1;
				g_iCountDown=30;
			}
		}
	}
	// tO`FbNɏ
	for(i=0;i<=5;i++){ for(j=0;j<=5;j++){ if(flash[j][i]==1) g_stageBuffer[j][i]='0'; } }
}
